;;; $Id: set-ops.scm,v 1.2 2001/09/18 07:51:23 leavens Exp leavens $

;;; Copy this file to your own directory and add your code to it as instructed
;;;---------------------------------------------------------------------

(displayln "Name:  <your name>")
(displayln "Section: <your section letter (A or B)>, <your TA name>")

;;;---------------------------------------------------------------------
;;; Do not change any of the following provided procedures
;;; The code you are to write follows them.
;;;---------------------------------------------------------------------

(defrep (forall (T) (set-of T)) (forall (T) (list-of T)))

(deftype the-empty-set (forall (T) (set-of T)))
(define the-empty-set '())

(deftype set-empty? (forall (T) (-> ((set-of T)) boolean)))
(define set-empty?
  (lambda (s) (null? s)))

(deftype set-size (forall (T) (-> ((set-of T)) number)))
(define set-size (lambda (s) (length s)))

(deftype set (forall (T) (-> (T ...) (set-of T))))
(define set
  (lambda args
    (if (null? args)
	the-empty-set
	(set-add (car args) (apply set (cdr args))))))

(deftype set-member? (forall (T) (-> (T (set-of T)) boolean)))
(define set-member?
  (lambda (e S)
    (and (not (set-empty? S))
	 (or (equal? e (car S))
	     (set-member? e (cdr S))))))

(deftype set-one-elem (forall (T) (-> ((set-of T)) T)))
(define set-one-elem
  (lambda (s)
    ;; REQUIRES: s is not empty
    (car s)))

(deftype set-rest (forall (T) (-> ((set-of T)) (set-of T))))
(define set-rest 
  (lambda (s)
    ;; REQUIRES: s is not empty
    (cdr s)))


(deftype set-subset? (forall (T) (-> ((set-of T) (set-of T)) boolean)))
(define set-subset?
  (lambda (S1 S2)
    (or (set-empty? S1)
	(and (set-member? (set-one-elem S1) S2)
	     (set-subset? (set-rest S1) S2)))))

(deftype set-equal? (forall (T) (-> ((set-of T) (set-of T)) boolean)))
(define set-equal?
  (lambda (S1 S2)
    (and (set-subset? S1 S2)
	 (set-subset? S2 S1))))

;;;---------------------------------------------------------------------
;;; End of provided code
;;;---------------------------------------------------------------------

;;;---------------------------------------------------------------------
;;; Put your code for each procedure below the corresponding deftype:
;;;---------------------------------------------------------------------
(deftype set-add
  (forall (T) (-> (T (set-of T)) (set-of T))))


(deftype set-remove
  (forall (T) (-> (T (set-of T)) (set-of T))))


(deftype set-union
  (forall (T) (-> ((set-of T) (set-of T)) (set-of T))))


(deftype set-minus
  (forall (T) (-> ((set-of T) (set-of T)) (set-of T))))


(deftype set-intersect
  (forall (T) (-> ((set-of T) (set-of T)) (set-of T))))


(deftype set-union-list
  (forall (T) (-> ((list-of (set-of T))) (set-of T))))


(deftype set-union*
  (forall (T) (-> ((set-of T) ...) (set-of T))))

