;; $Id: bound-vars-lambda+if-exp.tst,v 1.5 2001/10/30 22:53:24 leavens Exp leavens $

(newline)
(displayln "Test case of $Date: 2001/10/30 22:53:24 $")
(newline)

(load-from-lib "set-equal.scm")
(load-from-lib "lambda+if-exp.scm")

(define lexp1 '(lambda (x y) (if p (f x g) (f y h))))
(define lexp2 `(lambda (f g h y p) (,lexp1 (if g (quote h) y))))
(define lexp3 `(lambda (f) ,lexp2))
(define lexp4 `(lambda (z) (,lexp3 (if (null? (car (cdr x))) y z))))
(define lexp5 `(lambda (x y z) ,lexp4))
(define lexp6 `(lambda (null? car cdr) ,lexp5))
(define lexp7 `(,lexp1 (if g h y) ,lexp4 ,lexp5))
(define lexp8 `(lambda (car cdr) (lambda () ,lexp5)))

(define run-regression-tests-set-equal?
  ;; TYPE: (-> ((3-list scheme-exp symbol datum)) void)
  (run-regression-tests-maker
   cs342:left-protected-set-equal?
   pretty-print
   pretty-print))

(run-regression-tests-set-equal?
 `(
   ( (bound-vars (parse-lambda+if-exp 'x)) ==> () )
   ( (bound-vars (parse-lambda+if-exp '(x y))) ==> () )
   ( (bound-vars (parse-lambda+if-exp
		     '(lambda () (lambda (x) (if p (f x) (f y)))))) 
     ==> (x) )
   ( (bound-vars (parse-lambda+if-exp '(if p p y)))
     ==> () )
   ( (bound-vars (parse-lambda+if-exp '(lambda (p) (if p y p))))
     ==> (p) )
   ( (bound-vars (parse-lambda+if-exp
		     '(lambda () (lambda (x) (if p (f (quote x)) (f y)))))) 
     ==> () )
   ( (bound-vars (parse-lambda+if-exp
		     '(lambda (z) (lambda (x) (if p (f x) (f y))))))
     ==> (x) )
   ( (bound-vars (parse-lambda+if-exp
		     '(lambda (z) (lambda (z) (if p (f x) (f y))))))
     ==> () )
   ( (bound-vars (parse-lambda+if-exp '(lambda (x y) (lambda (x z) (y z)))))
     ==> (y z) )
   ( (bound-vars (parse-lambda+if-exp ',lexp1)) ==> (x y) )
   ( (bound-vars (parse-lambda+if-exp ',lexp2)) ==> (p f h g x y) )
   ( (bound-vars (parse-lambda+if-exp ',lexp3)) ==> (p f h g x y) )
   ( (bound-vars (parse-lambda+if-exp ',lexp4)) ==> (z p f h g x y) )
   ( (bound-vars (parse-lambda+if-exp ',lexp5)) ==> (z p f h g x y) )
   ( (bound-vars (parse-lambda+if-exp ',lexp6))
     ==> (null? car cdr z p f g h y x) )
   ( (bound-vars (parse-lambda+if-exp ',lexp7))
     ==> (z p f h g x y) )
   ( (bound-vars (parse-lambda+if-exp ',lexp8))
     ==> (car cdr z p f h g y x) )
   )
 )
