;; $Id: free-vars-lambda+if-exp.tst,v 1.2 2001/10/30 07:16:03 leavens Exp $

(newline)
(displayln "Test case of $Date: 2001/10/30 07:16:03 $")
(newline)

(load-from-lib "set-equal.scm")
(load-from-lib "lambda+if-exp.scm")

(define lexp1 '(lambda (x y) (if p (f x g) (f y h))))
(define lexp2 `(lambda (f g h y p) (,lexp1 (if g (quote h) y))))
(define lexp3 `(lambda (f) ,lexp2))
(define lexp4 `(,lexp3 (if (null? (car (cdr x))) (quote y) z)))
(define lexp5 `(lambda (x y z) ,lexp4))
(define lexp6 `(lambda (null? car cdr) ,lexp5))
(define lexp7 `(,lexp1 ,lexp4 ,lexp5))

(define run-regression-tests-set-equal?
  ;; TYPE: (-> ((3-list scheme-exp symbol datum)) void)
  (run-regression-tests-maker
   cs342:left-protected-set-equal?
   pretty-print
   pretty-print))

(run-regression-tests-set-equal?
 `(
   ( (free-vars (parse-lambda+if-exp 'x))      ==> (x) )
   ( (free-vars (parse-lambda+if-exp '(x y)))  ==> (x y) )
   ( (free-vars (parse-lambda+if-exp '(car (x y)))) ==> (car x y) )
   ( (free-vars (parse-lambda+if-exp '(if p (f x g) (f y h))))
     ==> (x p g f y h) )
   ( (free-vars (parse-lambda+if-exp ',lexp1)) ==> (p g f h) ) 
   ( (free-vars (parse-lambda+if-exp ',lexp2)) ==> () ) 
   ( (free-vars (parse-lambda+if-exp ',lexp3)) ==> () ) 
   ( (free-vars (parse-lambda+if-exp ',lexp4)) ==> (null? car cdr x z) )
   ( (free-vars (parse-lambda+if-exp ',lexp5)) ==> (null? car cdr) ) 
   ( (free-vars (parse-lambda+if-exp ',lexp6)) ==> () )
   ( (free-vars (parse-lambda+if-exp ',lexp7))
     ==> (null? car cdr x z p f g h) )
   ))

