;; $Id: lexical-address.tst,v 1.3 2004/03/07 05:13:54 leavens Exp leavens $

(newline)
(displayln "Test case of $Date: 2004/03/07 05:13:54 $")
(newline)

(define lexp0 '(lambda (x z) (if p (f x g) (f y h))))
(define lexp1 '(lambda (x) (if p (f x g) (f y h))))
(define lexp2 `(lambda (f g h y p) (,lexp1 (if g h y))))
(define lexp3 `(lambda (f) ,lexp2))
(define lexp4 `(,lexp3 (if (null? (car (cdr x))) y z)))
(define lexp5 `(lambda (x y z) ,lexp4))
(define lexp6 `(lambda (null? car cdr) ,lexp5))
(define lexp7 `(lambda (car cdr) ,lexp5))
(define lexp8 `(lambda (car cdr) (lambda () ,lexp5)))
(define lexp9 `(lambda (f g h y p) (,lexp1 (if g (quote h) (quote y)))))

(run-regression-tests-equal?
 `(
   (	(lexical-address (parse-lambda+if-exp 'car)) ==> (car : 0 0) )
   (	(lexical-address (parse-lambda+if-exp '(quote car))) ==> (quote car) )
   (	(lexical-address (parse-lambda+if-exp
			  '(lambda (f) (f (quote car)))))
	           ==> (lambda (f) ((f : 0 0) (quote car))) )
   (	(lexical-address (parse-lambda+if-exp 't)) ==> (t : 0 0) )
   (	(lexical-address (parse-lambda+if-exp '(lambda (car ls) (car ls))))
		   ==> (lambda (car ls) ((car : 0 0) (ls : 0 1))) )
   (	(lexical-address (parse-lambda+if-exp '(lambda (ls car) (car ls))))
		   ==> (lambda (ls car) ((car : 0 1) (ls : 0 0))) )
   (	(lexical-address (parse-lambda+if-exp '(lambda (ls car) (ls))))
		   ==> (lambda (ls car) ((ls : 0 0))) )
   ))

(run-test-case `(lexical-address (parse-lambda+if-exp '(car ls))))
(run-test-case `(lexical-address (parse-lambda+if-exp '(if t (car ls) ls))))
(run-test-case `(lexical-address (parse-lambda+if-exp '(eq? cons cons))))
(run-test-case `(lexical-address (parse-lambda+if-exp ',lexp0)))
(run-test-case `(lexical-address (parse-lambda+if-exp ',lexp1)))

(run-regression-tests-equal?
 `(
   ( (lexical-address (parse-lambda+if-exp ',lexp6)) ==>  

     (lambda (null? car cdr)
       (lambda (x y z)
	 ((lambda (f)
	    (lambda (f g h y p)
	      ((lambda (x)
		 (if (p : 1 4)
		     ((f : 1 0) (x : 0 0) (g : 1 1))
		     ((f : 1 0) (y : 1 3) (h : 1 2))))
	       (if (g : 0 1) (h : 0 2) (y : 0 3)))))
	  (if ((null? : 1 0)
	       ((car : 1 1) ((cdr : 1 2) (x : 0 0))))
	      (y : 0 1)
	      (z : 0 2))))) )

   ( (lexical-address (parse-lambda+if-exp ',lexp7)) ==>  

     (lambda (car cdr)
       (lambda (x y z)
	 ((lambda (f)
	    (lambda (f g h y p)
	      ((lambda (x)
		 (if (p : 1 4)
		     ((f : 1 0) (x : 0 0) (g : 1 1))
		     ((f : 1 0) (y : 1 3) (h : 1 2))))
	       (if (g : 0 1) (h : 0 2) (y : 0 3)))))
	  (if ((null? : 2 0)
	       ((car : 1 0) ((cdr : 1 1) (x : 0 0))))
	      (y : 0 1)
	      (z : 0 2))))) )

   ( (lexical-address (parse-lambda+if-exp ',lexp8)) ==>  

     (lambda (car cdr)
       (lambda ()
	 (lambda (x y z)
	   ((lambda (f)
	      (lambda (f g h y p)
		((lambda (x)
		   (if (p : 1 4)
		       ((f : 1 0) (x : 0 0) (g : 1 1))
		       ((f : 1 0) (y : 1 3) (h : 1 2))))
		 (if (g : 0 1) (h : 0 2) (y : 0 3)))))
	    (if ((null? : 3 0)
		 ((car : 2 0) ((cdr : 2 1) (x : 0 0))))
		(y : 0 1)
		(z : 0 2)))))) )

   ( (lexical-address (parse-lambda+if-exp ',lexp9)) ==>  

     (lambda (f g h y p)
       ((lambda (x)
	  (if (p : 1 4)
	      ((f : 1 0) (x : 0 0) (g : 1 1))
	      ((f : 1 0) (y : 1 3) (h : 1 2))))
	(if (g : 0 1) (quote h) (quote y)))) )

))
