;;; $Id: my-3-6-grammar.scm,v 1.1 2004/04/09 03:46:57 leavens Exp leavens $

;;;;;;;;;;;;;;;; grammatical specification ;;;;;;;;;;;;;;;;

(define the-lexical-spec
  '((whitespace (whitespace) skip)
    (comment ("%" (arbno (not #\newline))) skip)
    (identifier
      (letter (arbno (or letter digit "_" "-" "?")))
      symbol)
    (number (digit (arbno digit)) number)))

(define the-grammar
  '((program   
      ((arbno "define" identifier "(" (separated-list identifier ",") ")"
          "=" expression)
       expression)
      a-program)

    (expression (number) lit-exp)
    (expression (identifier) var-exp)   
    (expression
      (primitive "(" (separated-list expression ",") ")")
      primapp-exp)
    (expression
      ("if" expression "then" expression "else" expression)
      if-exp)
    (expression
      ("let" (arbno  identifier "=" expression) "in" expression)
      let-exp)
    (expression
      ("proc" "(" (separated-list identifier ",") ")" expression)
      proc-exp)
    (expression
      ("(" expression (arbno expression) ")")
      app-exp)

    (expression
      ("begin" expression (arbno ";" expression) "end")
      begin-exp)

    (expression                         ; new for 3-6
      ("letrec"
        (arbno identifier "(" (separated-list identifier ",") ")"
          "=" expression)
        "in" expression)
      letrec-exp)

    (primitive ("+")     add-prim)
    (primitive ("-")     subtract-prim)
    (primitive ("*")     mult-prim)
    (primitive ("add1")  incr-prim)
    (primitive ("sub1")  decr-prim)
    (primitive ("zero?") zero-test-prim)
    ;; exercise 3.5
    (primitive ("print")  print-prim)
    ;; exercise 3.6
    (primitive ("minus")  minus-prim)
    ;; exercise 3.7
    (primitive ("cons")  cons-prim)
    (primitive ("car")  car-prim)
    (primitive ("cdr")  cdr-prim)
    (primitive ("list")  list-prim)
    ;; exercise 3.11
    (primitive ("equal?")  equal?-prim)
    (primitive ("greater?")  greater?-prim)
    (primitive ("less?")  less?-prim)
    ;; exercise 3.12
    (primitive ("null?")  null?-prim)

    ;; for problem 4
    (primitive ("apply") apply-prim)
    ))

(deftype show-the-datatypes (-> () (list-of datum)))
(define show-the-datatypes
  (lambda ()
      (sllgen:make-define-datatypes the-lexical-spec the-grammar)
      (sllgen:list-define-datatypes the-lexical-spec the-grammar)))
