;;; $Id: indirect-arrays.scm,v 1.1 2004/04/13 05:43:29 leavens Exp leavens $
;;; Arrays in the indirect model

(public array-of make-array array-ref array-length array-set!)

;; type predicate
(deftype array-of (forall (T) (-> ((type-predicate-for T))
				  (type-predicate-for (array-of T)))))
;; constructor
(deftype make-array (forall (T) (-> (number) (array-of T))))

;; observers
(deftype array-ref (forall (T) (-> ((array-of T) number) T)))
(deftype array-length (forall (T) (-> ((array-of T)) number)))

;; mutator
(deftype array-set! (forall (T) (-> ((array-of T) number T) void)))

(defrep (array-of T) (vector-of T))

(define array-of
  (forall (T?)
    ;; ENSURES: result is true just when the argument is an array of T elements
    (vector-of T?)))

(define make-array
  (lambda (size)
    (make-vector size)))

(define array-ref
  (lambda (arr n)
    (vector-ref arr n)))

(define array-length
  (lambda (arr)
    (vector-length arr)))

(define array-set!
  (lambda (arr n val)
    (vector-set! arr n val)))
