;;; $Id: my-3-7-expressed-value.scm,v 1.2 2004/04/13 07:36:39 leavens Exp leavens $

trustme!  ; procval? is not defined here

(public Expressed-Value?
	number->expressed procval->expressed
	expressed->number expressed->procval
	array->expressed expressed->array
	denoted->expressed expressed->denoted
	)

(deftype Expressed-Value? (type-predicate-for Expressed-Value))

;; upcasts
(deftype number->expressed (-> (number) Expressed-Value))
(deftype procval->expressed (-> (Procval) Expressed-Value))
(deftype array->expressed (-> ((array-of Expressed-Value)) Expressed-Value))
(deftype denoted->expressed (-> ((ref-of Expressed-Value)) Expressed-Value))

;; downcasts
(deftype expressed->number (-> (Expressed-Value) number))
(deftype expressed->procval (-> (Expressed-Value) Procval))
(deftype expressed->array (-> (Expressed-Value) (array-of Expressed-Value)))
(deftype expressed->denoted (-> (Expressed-Value) (ref-of Expressed-Value)))

(defrep Expressed-Value datum)

(load-quietly-from-lib "inject-extract.scm")

(define Expressed-Value?
  (has-type-trusted
    (type-predicate-for Expressed-Value)
    (lambda (x)
      (or (number? x)
	  (procval? x)
	  ((array-of Expressed-Value?) x)))))

(define number->expressed
  inject)

(define procval->expressed
  inject)

(define array->expressed
  inject)

(define denoted->expressed
  inject)

(define expressed-value:extract
  (extract-maker "expressed"))

(define expressed->number
  (expressed-value:extract number? "number"))

;; the following use wrapped type predicates to avoid load order dependencies

(define expressed->procval
  (expressed-value:extract (lambda (x) (procval? x)) "procval"))

(define expressed->array
  (expressed-value:extract (lambda (x) (array-of Expressed-Value?) x) "array"))

(define expressed->denoted
  (expressed-value:extract (lambda (x) (ref-of Expressed-Value?) x) "ref"))
