;;; $Id: my-3-7-grammar.scm,v 1.2 2004/04/13 07:36:39 leavens Exp leavens $

(define the-lexical-spec
  '((whitespace (whitespace) skip)
    (comment ("%" (arbno (not #\newline))) skip)
    (identifier
      (letter (arbno (or letter digit "_" "-" "?")))
      symbol)
    (number (digit (arbno digit)) number)))

(define the-grammar
  '((program (expression) a-program)
    (expression (number) lit-exp)
    (expression (identifier) var-exp)   
    (expression
      (primitive "(" (separated-list expression ",") ")")
      primapp-exp)
    (expression
      ("if" expression "then" expression "else" expression)
      if-exp)
   (expression
      ("let" (arbno  identifier "=" expression) "in" expression)
      let-exp)
    (expression
      ("proc" "(" (separated-list identifier ",") ")" expression)
      proc-exp)
    (expression
      ("(" expression (arbno expression) ")")
      app-exp)
    (expression
      ("begin" expression (arbno ";" expression) "end")
      begin-exp)
    (expression                         
      ("letrec"
        (arbno identifier "(" (separated-list identifier ",") ")"
          "=" expression)
        "in" expression)
      letrec-exp)
    (expression ("set" identifier "=" expression) varassign-exp)

    ;; added for exercise 3.43
    (expression ("ref" identifier) ref-exp)

    (primitive ("+")     add-prim)
    (primitive ("-")     subtract-prim)
    (primitive ("*")     mult-prim)
    (primitive ("add1")  incr-prim)
    (primitive ("sub1")  decr-prim)
    (primitive ("zero?") zero-test-prim)

    ;; added for exercise 3.42 + arraylen
    (primitive ("array") array-prim)
    (primitive ("arrayref") arrayref-prim)
    (primitive ("arraylen") arraylen-prim)
    (primitive ("arrayset") arrayset-prim)

    ;; added for exercise 3.43
    (primitive ("deref") deref-prim)
    (primitive ("setref") setref-prim)
    
    ))

(deftype show-the-datatypes (-> () (list-of datum)))
(define show-the-datatypes
  (lambda ()
      (sllgen:make-define-datatypes the-lexical-spec the-grammar)
      (sllgen:list-define-datatypes the-lexical-spec the-grammar)))
